diff --git src/daemon/common/commonSwarming.ml src/daemon/common/commonSwarming.ml
index 1e018f7..a044c59 100644
--- src/daemon/common/commonSwarming.ml
+++ src/daemon/common/commonSwarming.ml
@@ -1347,7 +1441,7 @@ let set_frontend_state_verified t j =
       (* The primary is supposed to propagate verified chunks to the file *)
       List.iter (fun i -> set_verified_block s i) t.t_blocks_of_chunk.(j);
       if !verbose_swarming then
-	print_s "VERIFIED" s
+        print_s "VERIFIED" s
     end;
     t.t_verified t.t_nverified_chunks j in
     if j = 0 && !Autoconf.magic_works then check_magic t.t_file;
@@ -1365,11 +1459,11 @@ let set_chunks_verified_bitmap t bitmap =
   VB.iteri (fun j c ->
     match c with
     | VB.State_missing | VB.State_partial -> 
-	()
+        ()
     | VB.State_complete ->
-	set_frontend_state_complete t j
+        set_frontend_state_complete t j
     | VB.State_verified ->
-	set_frontend_state_verified t j;
+        set_frontend_state_verified t j;
         if VB.get t.t_converted_verified_bitmap j <> VB.State_verified then
           lprintf_nl "FIELD AS BEEN CLEARED"
   ) bitmap
@@ -1408,28 +1502,28 @@ let verify_chunk t j =
           let chunk_end = min chunk_end s.s_size in
           if verify t uids.(j) chunk_begin chunk_end then
             set_frontend_state_verified t j
-	  else
-	    set_frontend_state_missing t j
+          else
+            set_frontend_state_missing t j
         with VerifierNotReady -> ())
 
     | Verification chunks ->
-	(* network only provides a hash for the whole file ? *)
+        (* network only provides a hash for the whole file ? *)
         assert (Array.length chunks = 1);
 (*        let nchunks = String.length t.t_converted_verified_bitmap in *)
 
-	if VB.for_all (function
-	  | VB.State_missing | VB.State_partial -> false
-	  | VB.State_complete | VB.State_verified -> true) t.t_converted_verified_bitmap then
+        if VB.for_all (function
+          | VB.State_missing | VB.State_partial -> false
+          | VB.State_complete | VB.State_verified -> true) t.t_converted_verified_bitmap then
           try
             let s = t.t_s in
             if verify t chunks.(0) zero s.s_size then
-	      VB.iteri (fun j _ ->
-		set_frontend_state_verified t j
-	      ) t.t_converted_verified_bitmap
-	    else
-	      VB.iteri (fun j c ->
-		if c = VB.State_complete then set_frontend_state_missing t j
-	      ) t.t_converted_verified_bitmap
+              VB.iteri (fun j _ ->
+                set_frontend_state_verified t j
+              ) t.t_converted_verified_bitmap
+            else
+              VB.iteri (fun j c ->
+                if c = VB.State_complete then set_frontend_state_missing t j
+              ) t.t_converted_verified_bitmap
           with VerifierNotReady -> ()
 
 
@@ -1445,12 +1539,12 @@ let verify_all_chunks t =
   VB.iteri (fun i state -> 
     match state with
     | VB.State_verified ->
-	must_verify_block s i
+        must_verify_block s i
     | VB.State_missing ->
-	let block_begin = compute_block_begin s i in
-	let block_end = compute_block_end s i in
-	add_file_downloaded None s (block_end -- block_begin);
-	must_verify_block s i
+        let block_begin = compute_block_begin s i in
+        let block_end = compute_block_end s i in
+        add_file_downloaded None s (block_end -- block_begin);
+        must_verify_block s i
     | VB.State_partial | VB.State_complete -> ()
   ) s.s_verified_bitmap
 
@@ -1536,24 +1630,24 @@ let range_received maybe_t r interval_begin interval_end =
       (match r.range_prev with
        | Some rr -> rr.range_next <- r.range_next
        | None ->
-	   (* that was the first range of the block *)
+           (* that was the first range of the block *)
            match r.range_next with
            | Some rr -> (* fix block's first range *)
-	       b.block_ranges <- rr
+               b.block_ranges <- rr
            | None -> (* that was the last remaining range of the block *)
-	       match s.s_blocks.(b.block_num) with
-	       | PartialBlock _ | EmptyBlock ->
-		   (match s.s_networks with
-		   | t :: _ -> 
-		       assert(t.t_primary);
-		       (match t.t_verifier with
-		       | NoVerification ->
-			   set_verified_block s b.block_num
-		       | _ ->
-			   set_completed_block (Some t) s b.block_num;
-			   must_verify_block s b.block_num)
-		   | [] -> assert false)
-	       | _ -> () );
+               match s.s_blocks.(b.block_num) with
+               | PartialBlock _ | EmptyBlock ->
+                   (match s.s_networks with
+                   | t :: _ -> 
+                       assert(t.t_primary);
+                       (match t.t_verifier with
+                       | NoVerification ->
+                           set_verified_block s b.block_num
+                       | _ ->
+                           set_completed_block (Some t) s b.block_num;
+                           must_verify_block s b.block_num)
+                   | [] -> assert false)
+               | _ -> () );
       r.range_next <- None;
       r.range_prev <- None;
     end (* else begin
@@ -1619,7 +1713,7 @@ let set_present s intervals =
     | EmptyBlock ->
 (*          lprintf "  EmptyBlock"; *)
         if block_begin >= interval_begin && block_end <= interval_end
-	then begin
+        then begin
 (*              lprintf " --> CompleteBlock\n"; *)
           s.s_blocks.(i) <- CompleteBlock;
           must_verify_block s i;
@@ -1639,7 +1733,7 @@ let set_present s intervals =
   match s.s_networks with
   | tprim :: _ ->
       List.iter (fun (interval_begin, interval_end) ->
-	mark_disk_space_preallocated tprim interval_begin interval_end;
+        mark_disk_space_preallocated tprim interval_begin interval_end;
       ) intervals
   | [] -> assert false
 
@@ -1651,17 +1745,17 @@ let set_absent s list_absent =
   let rec complementary acc set_begin set_end intervals =
     match intervals with
     | [] ->
-	let acc =
+        let acc =
           if set_begin = set_end then acc else
             (set_begin, set_end) :: acc
-	in
-	List.rev acc
+        in
+        List.rev acc
     | (interval_begin, interval_end) :: other_intervals ->
-	let acc =
+        let acc =
           if set_begin = interval_begin then acc
           else (set_begin, interval_begin) :: acc
-	in
-	complementary acc interval_end set_end other_intervals in
+        in
+        complementary acc interval_end set_end other_intervals in
   let list_present = complementary [] Int64.zero s.s_size list_absent in
   set_present s list_present
 
@@ -1723,7 +1817,7 @@ let set_uploader_intervals up intervals =
          incr_availability s i;
 
          match s.s_blocks.(i) with
-	 | CompleteBlock | VerifiedBlock -> ()
+         | CompleteBlock | VerifiedBlock -> ()
          | EmptyBlock | PartialBlock _ ->
              if block_begin = interval_begin && block_end = interval_end then
                complete_blocks := i :: !complete_blocks
@@ -1813,9 +1907,9 @@ let clear_uploader_ranges up =
     if r.range_nuploading = 0 then
       let b = r.range_block in
       b.block_unselected_remaining <-
-	b.block_unselected_remaining ++ (compute_range_size r);
+        b.block_unselected_remaining ++ (compute_range_size r);
       if b.block_unselected_remaining > b.block_remaining then
-	lprintf_nl "clear_uploader_ranges: block_unselected_remaining larger than block_remaining!";
+        lprintf_nl "clear_uploader_ranges: block_unselected_remaining larger than block_remaining!";
   ) up.up_ranges;
   up.up_ranges <- []
 
@@ -1838,9 +1932,9 @@ let clear_uploader_intervals up =
   if up.up_declared then
     let decr_availability s i =
       if s.s_availability.(i) > 0 then
-	s.s_availability.(i) <- s.s_availability.(i) - 1 
+        s.s_availability.(i) <- s.s_availability.(i) - 1 
       else 
-	lprintf_nl "clear_uploader_intervals: some s_availability was about to become negative\n" in
+        lprintf_nl "clear_uploader_intervals: some s_availability was about to become negative\n" in
 (*          lprintf "clean_uploader_chunks:\n"; *)
     let t = up.up_t in
     let s = t.t_s in
@@ -1884,9 +1978,9 @@ let print_uploaders s =
     | PartialBlock b ->
         lprintf "{ %d : %d=" b.block_num
           s.s_nuploading.(b.block_num);
-	iter_block_ranges (fun r -> 
+        iter_block_ranges (fun r -> 
           lprintf "(%d)" r.range_nuploading
-	) b;
+        ) b;
         lprintf " }";
   ) s.s_blocks;
   lprint_newline ()
@@ -1914,14 +2008,14 @@ let permute_and_return up n =
   | EmptyBlock ->
       let b = new_block s b in
       { 
-	up_block = b;
-	up_block_begin = b.block_begin;
-	up_block_end = b.block_end }
+        up_block = b;
+        up_block_begin = b.block_begin;
+        up_block_end = b.block_end }
   | PartialBlock b ->
       {
-	up_block = b;
-	up_block_begin = b.block_begin;
-	up_block_end = b.block_end }
+        up_block = b;
+        up_block_begin = b.block_begin;
+        up_block_end = b.block_end }
   | VerifiedBlock ->
       lprintf_nl "ERROR: verified block in permute_and_return %d\n" b;
       assert false
@@ -1950,24 +2044,24 @@ let linear_select_blocks up =
     up.up_npartial <- n-1;
     let t = up.up_t in
     let s = t.t_s in
-    (* priority bitmap <> 0 here ? *)
+    if s.s_priorities_bitmap.[b] = priority_zero then iter_partial up else
     let chunk = t.t_chunk_of_block.(b) in
     match s.s_blocks.(b) with
     | CompleteBlock | VerifiedBlock ->
         iter_partial up
     | PartialBlock b ->
-	chunk,
+        chunk,
         [{ 
-	  up_block = b; 
-	  up_block_begin = block_begin; 
-	  up_block_end = block_end }]
+          up_block = b; 
+          up_block_begin = block_begin; 
+          up_block_end = block_end }]
     | EmptyBlock ->
         let b = new_block s b in
-	chunk, 
+        chunk, 
         [{
-	  up_block = b;
-	  up_block_begin = block_begin;
-	  up_block_end = block_end }] in
+          up_block = b;
+          up_block_begin = block_begin;
+          up_block_end = block_end }] in
   let rec iter_complete up =
     let n = up.up_ncomplete in
     if n = 0 then iter_partial up
@@ -1976,24 +2070,24 @@ let linear_select_blocks up =
       up.up_ncomplete <- n-1;
       let t = up.up_t in
       let s = t.t_s in
-      (* priority bitmap <> 0 here ? *)
+      if s.s_priorities_bitmap.[b] = priority_zero then iter_complete up else
       let chunk = t.t_chunk_of_block.(b) in
       match s.s_blocks.(b) with
       | CompleteBlock | VerifiedBlock ->
           iter_complete up
       | PartialBlock b ->
-	  chunk,
+          chunk,
           [{
-	    up_block = b;
-	    up_block_begin = b.block_begin;
-	    up_block_end = b.block_end }]
+            up_block = b;
+            up_block_begin = b.block_begin;
+            up_block_end = b.block_end }]
       | EmptyBlock ->
           let b = new_block s b in
-	  chunk,
+          chunk,
           [{
-	    up_block = b;
-	    up_block_begin = b.block_begin;
-	    up_block_end = b.block_end }]
+            up_block = b;
+            up_block_begin = b.block_begin;
+            up_block_end = b.block_end }]
   in
   iter_complete up
 
@@ -2012,16 +2106,16 @@ let should_download_block s n =
     | VB.State_complete ->
         (match s.s_networks with
          | t :: _ ->
-	     assert(t.t_primary);
+             assert(t.t_primary);
              (try
                let n = t.t_chunk_of_block.(n) in
                if VB.get t.t_converted_verified_bitmap n = VB.State_complete then
                  verify_chunk t n
              with VerifierNotReady -> ());
-	 | [] -> assert false);
+         | [] -> assert false);
         (match VB.get s.s_verified_bitmap n with
          | VB.State_missing | VB.State_partial ->  true
-	 | VB.State_complete | VB.State_verified -> false)
+         | VB.State_complete | VB.State_verified -> false)
     | VB.State_verified -> false
   in
 (*  if result then
@@ -2068,154 +2162,152 @@ let select_blocks up =
 (* to evaluate the relative rarity of a block, we must compare it to
    the availability of *all* blocks, not only those available from
    that uploader *)
-	let sum_availability = Array.fold_left (+) 0 s.s_availability in
-	let mean_availability = sum_availability / Array.length s.s_blocks in
-
-	let my_t = if t.t_verifier <> NoVerification then t else 
-	  match s.s_networks with
-	    | tprim :: _ ->
-		assert(tprim.t_primary);
-		tprim
-	    | [] -> assert false in
-	let verification_available = my_t.t_verifier <> NoVerification in
-
-	let several_frontends = List.length s.s_networks > 1 in
-	(* compute the number of missing or partial blocks in the same
-	   chunks (for all networks) as a given block *)
-	(* memoize some results *)
-	let memoization_calls = ref 0 in
-	let memoization_hits = ref 0 in
-	let debug_memoization = false in
-	let memoize h f p =
-	  incr memoization_calls;
-	  try
-	    let result = Hashtbl.find h p in
-	    incr memoization_hits;
-	    if debug_memoization then
-	      (* defeats the purpose of memoization, only enable for
-		 debugging *)
-	      let recomputed_result = f p in
-	      if result <> recomputed_result then begin
-		lprintf_nl "memoization failure";
-		recomputed_result
-	      end else result
-	    else result
-	  with Not_found ->
-	    let result = f p in
-	    Hashtbl.add h p result;
-	    result in
-	let memoize_remaining_blocks_in_chunk = Hashtbl.create 17 in
-	let memoize_remaining_blocks_in_chunks = Hashtbl.create 17 in
-
- 	let remaining_blocks_in_chunks i = 
-	  assert (i >= 0 && i < VB.length s.s_verified_bitmap);
-	  memoize memoize_remaining_blocks_in_chunks
-	    (fun i ->
- 	      List.fold_left (fun acc t ->
-		acc + 
-		  (memoize memoize_remaining_blocks_in_chunk
-		    (fun (tnum, i) ->
- 		      let chunk = t.t_chunk_of_block.(i) in
- 		      List.fold_left (fun acc b ->
- 			if b <> i &&
- 			  (match VB.get s.s_verified_bitmap b with
-			  | VB.State_missing | VB.State_partial -> true
-			  | VB.State_complete | VB.State_verified -> false) then acc + 1
- 			else acc) 0 t.t_blocks_of_chunk.(chunk)) (t.t_num, i))
- 	      ) 0 s.s_networks) i in
-
-	let preview_beginning = 9000000L in
-	let preview_end = (s.s_size ** 98L) // 100L in
-
-	(* sources_per_chunk was initially for edonkey only *)
-	let data_per_source = 9728000L // (Int64.of_int !!sources_per_chunk) in
-	
-	let need_to_complete_some_blocks_quickly = 
-	  verification_available && t.t_nverified_chunks < 2
+        let sum_availability = Array.fold_left (+) 0 s.s_availability in
+        let mean_availability = sum_availability / Array.length s.s_blocks in
+
+        let my_t = if t.t_verifier <> NoVerification then t else 
+          match s.s_networks with
+            | tprim :: _ ->
+                assert(tprim.t_primary);
+                tprim
+            | [] -> assert false in
+        let verification_available = my_t.t_verifier <> NoVerification in
+
+        let several_frontends = List.length s.s_networks > 1 in
+        (* compute the number of missing or partial blocks in the same
+           chunks (for all networks) as a given block *)
+        (* memoize some results *)
+        let memoization_calls = ref 0 in
+        let memoization_hits = ref 0 in
+        let debug_memoization = false in
+        let memoize h f p =
+          incr memoization_calls;
+          try
+            let result = Hashtbl.find h p in
+            incr memoization_hits;
+            if debug_memoization then
+              (* defeats the purpose of memoization, only enable for
+                 debugging *)
+              let recomputed_result = f p in
+              if result <> recomputed_result then begin
+                lprintf_nl "memoization failure";
+                recomputed_result
+              end else result
+            else result
+          with Not_found ->
+            let result = f p in
+            Hashtbl.add h p result;
+            result in
+        let memoize_remaining_blocks_in_chunk = Hashtbl.create 17 in
+        let memoize_remaining_blocks_in_chunks = Hashtbl.create 17 in
+
+         let remaining_blocks_in_chunks i = 
+          assert (i >= 0 && i < VB.length s.s_verified_bitmap);
+          memoize memoize_remaining_blocks_in_chunks
+            (fun i ->
+               List.fold_left (fun acc t ->
+                acc + 
+                  (memoize memoize_remaining_blocks_in_chunk
+                    (fun (tnum, i) ->
+                       let chunk = t.t_chunk_of_block.(i) in
+                       List.fold_left (fun acc b ->
+                         if b <> i &&
+                           (match VB.get s.s_verified_bitmap b with
+                          | VB.State_missing | VB.State_partial -> true
+                          | VB.State_complete | VB.State_verified -> false) then acc + 1
+                         else acc) 0 t.t_blocks_of_chunk.(chunk)) (t.t_num, i))
+               ) 0 s.s_networks) i in
+
+        let preview_beginning = 9000000L in
+        let preview_end = (s.s_size ** 98L) // 100L in
+
+        (* sources_per_chunk was initially for edonkey only *)
+        let data_per_source = 9728000L // (Int64.of_int !!sources_per_chunk) in
+        
+        let need_to_complete_some_blocks_quickly = 
+          verification_available && t.t_nverified_chunks < 2
         in
 
-	let create_choice n b =
-	  let block_begin = compute_block_begin s b in
-	  let block_end = compute_block_end s b in
-	  let size = block_end -- block_begin in
-	  let remaining, unselected_remaining = match s.s_blocks.(b) with
-	    | EmptyBlock -> size, size
-	    | PartialBlock b -> b.block_remaining, b.block_unselected_remaining
-	    | CompleteBlock | VerifiedBlock -> 0L, 0L in
-	  {
-	    choice_num = n;
-	    choice_block = b;
-	    choice_user_priority = (* priority bitmap here instead ? *)
-	      if block_begin < preview_beginning then 3 else
-		if block_end > preview_end then 2 else 1;
-	    choice_remaining = remaining;
+        let create_choice n b =
+          let block_begin = compute_block_begin s b in
+          let block_end = compute_block_end s b in
+          let size = block_end -- block_begin in
+          let remaining, unselected_remaining = match s.s_blocks.(b) with
+            | EmptyBlock -> size, size
+            | PartialBlock b -> b.block_remaining, b.block_unselected_remaining
+            | CompleteBlock | VerifiedBlock -> 0L, 0L in
+          {
+            choice_num = n;
+            choice_block = b;
+            choice_user_priority = Char.code s.s_priorities_bitmap.[b];
+            choice_remaining = remaining;
             choice_preallocated = is_fully_preallocated t block_begin block_end;
-	    choice_unselected_remaining = unselected_remaining;
-	  } in
-
-	(* accessors *)
-	let choice_num choice =
-	  choice.choice_num in
-
-	let _choice_block choice =
-	  choice.choice_block in
-
-	let choice_user_priority choice =
-	  choice.choice_user_priority in
-
-	let choice_remaining choice =
-	  choice.choice_remaining in
-
-	let choice_unselected_remaining choice =
-	  choice.choice_unselected_remaining in
-
-	let choice_nuploaders choice =
-	  s.s_nuploading.(choice.choice_block) in
-
-	let choice_remaining_per_uploader choice =
-	  choice.choice_unselected_remaining //
-	    (Int64.of_int (choice_nuploaders choice + 1)) (* planned *) in
-
-	(* has enough uploaders *)
-	let choice_saturated choice =
-	  choice.choice_unselected_remaining <= 
-	    Int64.of_int (choice_nuploaders choice) ** data_per_source in
-
-	let choice_availability choice =
-	  s.s_availability.(choice.choice_block) in
-
-	(* remaining blocks in the same chunk, for all frontends *)
-	let choice_other_remaining choice =
-	  remaining_blocks_in_chunks (choice.choice_block) in
-
-	let choice_preallocated choice =
-	  choice.choice_preallocated in
-	
-	let print_choice c =
-	  lprintf_nl "choice %d:%d priority:%d nup:%d rem:%Ld rmu:%Ld rpu:%Ld sat:%B sib:%d av:%d pre:%b" 
-	    (choice_num c) up.up_complete_blocks.(choice_num c)
-	    (choice_user_priority c)
-	    (choice_nuploaders c)
-	    (choice_remaining c)
-	    (choice_unselected_remaining c)
-	    (choice_remaining_per_uploader c)
-	    (choice_saturated c)
-	    (choice_other_remaining c) 
-	    (choice_availability c) 
-	    (choice_preallocated c) in
-
-	(** > 0 == c1 is best, < 0 = c2 is best, 0 == they're equivalent *)
-	let compare_choices c1 c2 =
-	  (* "RULES" *)
-	  (* Avoid stepping on each other's feet *)
-	  let cmp =
-	    match choice_unselected_remaining c1,
-	    choice_unselected_remaining c2 with
-	    | 0L, 0L -> 0
-	    | _, 0L -> 1
-	    | 0L, _ -> -1
-	    | _, _ -> 0 in
-	  if cmp <> 0 then cmp else
+            choice_unselected_remaining = unselected_remaining;
+          } in
+
+        (* accessors *)
+        let choice_num choice =
+          choice.choice_num in
+
+        let _choice_block choice =
+          choice.choice_block in
+
+        let choice_user_priority choice =
+          choice.choice_user_priority in
+
+        let choice_remaining choice =
+          choice.choice_remaining in
+
+        let choice_unselected_remaining choice =
+          choice.choice_unselected_remaining in
+
+        let choice_nuploaders choice =
+          s.s_nuploading.(choice.choice_block) in
+
+        let choice_remaining_per_uploader choice =
+          choice.choice_unselected_remaining //
+            (Int64.of_int (choice_nuploaders choice + 1)) (* planned *) in
+
+        (* has enough uploaders *)
+        let choice_saturated choice =
+          choice.choice_unselected_remaining <= 
+            Int64.of_int (choice_nuploaders choice) ** data_per_source in
+
+        let choice_availability choice =
+          s.s_availability.(choice.choice_block) in
+
+        (* remaining blocks in the same chunk, for all frontends *)
+        let choice_other_remaining choice =
+          remaining_blocks_in_chunks (choice.choice_block) in
+
+        let choice_preallocated choice =
+          choice.choice_preallocated in
+        
+        let print_choice c =
+          lprintf_nl "choice %d:%d priority:%d nup:%d rem:%Ld rmu:%Ld rpu:%Ld sat:%B sib:%d av:%d pre:%b" 
+            (choice_num c) up.up_complete_blocks.(choice_num c)
+            (choice_user_priority c)
+            (choice_nuploaders c)
+            (choice_remaining c)
+            (choice_unselected_remaining c)
+            (choice_remaining_per_uploader c)
+            (choice_saturated c)
+            (choice_other_remaining c) 
+            (choice_availability c) 
+            (choice_preallocated c) in
+
+        (** > 0 == c1 is best, < 0 = c2 is best, 0 == they're equivalent *)
+        let compare_choices c1 c2 =
+          (* "RULES" *)
+          (* Avoid stepping on each other's feet *)
+          let cmp =
+            match choice_unselected_remaining c1,
+            choice_unselected_remaining c2 with
+            | 0L, 0L -> 0
+            | _, 0L -> 1
+            | 0L, _ -> -1
+            | _, _ -> 0 in
+          if cmp <> 0 then cmp else
 
           (* avoid overly unbalanced situations *)
           let cmp =
